import requests
import qrcode
import time
import pickle
from pathlib import Path
import re
import json
from zhipuai import ZhipuAI

default_header = {
    "User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/128.0.0.0 Safari/537.36 Edg/128.0.0.0"
}

cookies_file = Path("cookies.pkl")
cookies = pickle.load(cookies_file.open("rb")) if cookies_file.exists() else None

ai_client = ZhipuAI(api_key="2bfd0fafc21fe17416187209f6e567a2.95ZNhikNEAOUQaUk")
base_msg = [
    {
        "role": "system",
        "content": "你是**一袋猫粮**，尝试使用一两段相关但将关键概念替换为**猫粮**的文字回复接下来的内容。保持友善，严禁使用emoji、分条目叙述或使用markdown格式。",
    }
]

def login():
    r = requests.get(
        "https://passport.bilibili.com/x/passport-login/web/qrcode/generate",
        headers=default_header,
    )

    url, key = r.json()["data"].values()

    img = qrcode.make(url)
    for line in img.modules:
        for white in line:
            v = 255 * (not white)
            print(f"\x1b[48;2;{v};{v};{v}m  \x1b[0m", end="")
        print()

    while True:
        r = requests.get(
            "https://passport.bilibili.com/x/passport-login/web/qrcode/poll",
            params={"qrcode_key": key},
            headers=default_header,
        )

        if r.json()["data"]["code"] == 0:
            pickle.dump(r.cookies, cookies_file.open("wb"))
            break

        time.sleep(1)
        continue
    
def b23tv_target(url: str):
    return requests.head(url).headers["location"].split("?", 1)[0]

def get_initial_state(url: str):
    r = requests.get(url, headers=default_header, cookies=cookies)
    m = re.search(r"window\.__INITIAL_STATE__=({[\s\S]+});", r.content.decode())
    return json.loads(m[1])

def get_ai_reply(s: str):
    msgs = base_msg.copy()
    msgs.append({"role": "user", "content": s})
    response = ai_client.chat.completions.create(model="glm-4", messages=msgs)
    return response.choices[0].message.content

def extract_content_module(module):
    s = ""
    for p in module["module_content"]["paragraphs"]:
        if p["para_type"] == 1:
            for node in p["text"]["nodes"]:
                match node["type"]:
                    case "TEXT_NODE_TYPE_WORD":
                        s += node["word"]["words"]
    return s.strip()

def send_reply(oid: int, comment_type: int, content: str):
    r = requests.post(
        "https://api.bilibili.com/x/v2/reply/add",
        {
            "type": comment_type,
            "oid": oid,
            "message": content,
            "csrf": cookies.get("bili_jct"),
        },
        headers=default_header,
        cookies=cookies
    )
    print(r.content.decode())

def comment_from_share(share_url: str):
    share_url = b23tv_target(share_url)
    initial_state = get_initial_state(share_url)
    comment_id = int(initial_state["detail"]["basic"]["comment_id_str"])
    comment_type = initial_state["detail"]["basic"]["comment_type"]
    for module in initial_state["detail"]["modules"]:
        if module["module_type"] == "MODULE_TYPE_CONTENT":
            content = extract_content_module(module)
    reply = get_ai_reply(content)
    send_reply(comment_id, comment_type, "行不行啊到底。。。")
    return reply


    
if __name__ == "__main__":

    if not cookies_file.exists():
        login()

    cookies: dict | None = pickle.load(cookies_file.open("rb"))

    comment_from_share(
        "https://b23.tv/rRaEHak?share_medium=android&share_source=qq&bbid=XYC260EC11E84017B2BD20F0AEE60BE8BF85E&ts=1725009149001"
    )


# r = requests.get(
#     "https://www.googleapis.com/customsearch/v1",
#     params={
#         "key": "AIzaSyDKx0z9fQnzvifzb16nhW96NbFPy5bAH4g",
#         "cx": "92c962b5ae97f4c5a",
#         "q": "望周知",
#         "dateRestrict": "d1",
#     },
# )


# for item in r.json()["items"]:
#     r = requests.get(item["link"], headers=default_header, cookies=cookies)
#     m = re.search(r"window\.__INITIAL_STATE__=({[\s\S]+});", r.content.decode())
#     d = json.loads(m[1])
#     c = d["readInfo"]["content"]
#     s = ""
#     match d["readInfo"]["type"]:
#         case 0:
#             x = etree.HTML(c)
#             for p in x.xpath("//p"):
#                 s += p.text or ""
#         case 3:
#             x = json.loads(c)
#             for p in x["ops"]:
#                 if isinstance(p["insert"], str):
#                     s += p["insert"]
#         case _:
#             print(c)
#             continue
#     s = s.strip()
#     print(f"=============={item["link"]}===============")
#     print(s)
#     if len(s) == 0:
#         print("=============================")
#         continue
#     print("-----------------------------")
#     msgs = base_msg.copy()
#     msgs.append({"role": "user", "content": s})
#     response = (
#         ai_client.chat.completions.create(model="glm-4", messages=msgs)
#         .choices[0]
#         .message.content
#     )
#     print(response)
#     print("=============================")

# latest_time = 1724739630

# r = requests.get(
#     "https://api.bilibili.com/x/msgfeed/at",
#     headers=default_header,
#     cookies=cookies,
# )

# for item in r.json()["data"]["items"]:
#     if item["at_time"] > latest_time:
#         requests.post(
#             "https://api.bilibili.com/x/v2/reply/add",
#             {
#                 "type": item["item"]["business_id"],
#                 "oid": item["item"]["subject_id"],
#                 "message": "A",
#                 "csrf": cookies.get("bili_jct"),
#             },
#             headers=default_header,
#             cookies=cookies
#         )

#         requests.post(
#             "https://api.bilibili.com/x/v2/reply/add",
#             {
#                 "type": item["item"]["business_id"],
#                 "oid": item["item"]["subject_id"],
#                 "root": item["item"]["root_id"],
#                 "parent": item["item"]["source_id"],
#                 "message": "B",
#                 "csrf": cookies.get("bili_jct"),
#             },
#             headers=default_header,
#             cookies=cookies,
#         )
